diff --git a/fas/static/theme/fas/css/style.css b/fas/static/theme/fas/css/style.css
index 03e467a..fa7c6dc 100644
--- a/fas/static/theme/fas/css/style.css
+++ b/fas/static/theme/fas/css/style.css
@@ -522,3 +522,9 @@ legend
 {
   font-weight: bold;
 }
+
+/* Button Styles */
+input.sub-button{
+  min-width: 110px;
+  margin-left: 39ex;
+}
\ No newline at end of file
diff --git a/fas/templates/user/changepass.html b/fas/templates/user/changepass.html
index 189c024..1079c96 100644
--- a/fas/templates/user/changepass.html
+++ b/fas/templates/user/changepass.html
@@ -13,7 +13,7 @@
         <div class="field"><label for="currentpassword">${_('Current Password:')}</label> <input type="password" id="currentpassword" name="currentpassword" /></div>
         <div class="field"><label for="password">${_('New Password:')}</label> <input type="password" id="password" name="password" /></div>
         <div class="field"><label for="passwordcheck">${_('Confirm Password:')}</label> <input type="password" id="passwordcheck" name="passwordcheck" /></div>
-        <div class="field"><input type="submit" value="${_('Change Password')}" /></div>
+        <div class="field"><input class="sub-button" type="submit" value="${_('Change Password')}" /></div>
       </ul>
     </form>
   </body>
diff --git a/fas/templates/user/edit.html b/fas/templates/user/edit.html
index 89e6766..87868ed 100644
--- a/fas/templates/user/edit.html
+++ b/fas/templates/user/edit.html
@@ -143,7 +143,7 @@ Unfortunately, checked can't be used as a boolean, only as a flag.  Silly HTML4
         <script type="text/javascript">var hb_privacy = new HelpBalloon({dataURL: '${tg.url('/help/get_help/user_privacy')}'});</script>
       </div>
       <div class="field">
-        <input type="submit" value="${_('Save!')}" />
+        <input class="sub-button" type="submit" value="${_('Save!')}" />
         <a href="${tg.url('/user/view/%s' % target.username)}">${_('Cancel')}</a>
       </div>
     </form>
diff --git a/fas/templates/user/new.html b/fas/templates/user/new.html
index 8bd89be..678830a 100644
--- a/fas/templates/user/new.html
+++ b/fas/templates/user/new.html
@@ -55,7 +55,7 @@
         <label for="captcha">${_('Type the letters in the box')}</label>
       </div>
       <div class="field">
-        <input type="submit" value="${_('Sign up!')}" />
+        <input class="sub-button" type="submit" value="${_('Sign up!')}" />
       </div>
     </form>
   </body>
diff --git a/fas/templates/user/resetpass.html b/fas/templates/user/resetpass.html
index fba7953..0ad0e51 100644
--- a/fas/templates/user/resetpass.html
+++ b/fas/templates/user/resetpass.html
@@ -16,7 +16,7 @@
         - Encrypt and sign is currently broken.  Fix it later.
         <div class="field"><input type="checkbox" id="encrypted" name="encrypted" /> <label style="width: auto; float: none; margin-left: 1ex;" for="encrypted">${_('Encrypt/Sign password reset email')}</label></div>
         -->
-        <div class="field"><input type="submit" value="${_('Reset Password')}" /></div>
+        <div class="field"><input class="sub-button" type="submit" value="${_('Reset')}" /></div>
       </ul>
     </form>
   </body>
diff --git a/fas/templates/user/verifyemail.html b/fas/templates/user/verifyemail.html
index 9c5dab7..74ae675 100644
--- a/fas/templates/user/verifyemail.html
+++ b/fas/templates/user/verifyemail.html
@@ -13,7 +13,7 @@
         <p>
         ${_('Do you really want to change your email to: %s?') % person.unverified_email}
         </p>
-        <input type="submit" value="${_('Confirm')}" />
+        <input class="sub-button" type="submit" value="${_('Confirm')}" />
         <a href="${tg.url('/user/verifyemail/%s/%s/cancel') % (person.username, token)}">${_('Cancel')}</a>
       </div>
     </form>
diff --git a/fas/templates/user/verifypass.html b/fas/templates/user/verifypass.html
index 763dd54..5fcc9ea 100644
--- a/fas/templates/user/verifypass.html
+++ b/fas/templates/user/verifypass.html
@@ -13,7 +13,7 @@
         <div class="field"><label for="password">${_('New Password:')}</label> <input type="password" id="password" name="password" /></div>
         <div class="field"><label for="passwordcheck">${_('Confirm Password:')}</label> <input type="password" id="passwordcheck" name="passwordcheck" /></div>
         <div class="field">
-          <input type="submit" value="${_('Change Password')}" />
+          <input class="sub-button" type="submit" value="${_('Change Password')}" />
           <a href="${tg.url('/user/verifypass/%s/%s/cancel') % (person.username, token)}">${_('Cancel')}</a>
         </div>
       </ul>